﻿using Infragistics.Controls.Editors;
using Infragistics.Controls.Editors.Primitives;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Interactivity;
using MahApps.Metro.Controls;
using TestHdadmProject.CustomControls;
using System.Diagnostics;
using System.Windows.Data;
using System.Windows;

namespace TestHdadmProject.Behaviors
{
    public class XamEditComboValueBehaviour : Behavior<HDADMXamComboEditor>
    {
        HDADMXamComboEditor editor;

        protected override void OnAttached()
        {
            base.OnAttached();

            editor = AssociatedObject;
            editor.OpenDropDownOnTyping = false;

            AssociatedObject.Loaded += AssociatedObject_Loaded;
        }

        protected override void OnDetaching()
        {
            var tb = (SpecializedTextBox)Infragistics.Windows.Utilities.GetDescendantFromType(AssociatedObject, typeof(SpecializedTextBox), false); //GetDescendantFromName(AssociatedObject, "TextBoxPresenter");
            if (tb != null)
            {
                tb.TextChanged -= tb_TextChanged;
                tb.GotFocus -= tb_GotFoccused;
            }
        }

        void AssociatedObject_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            AssociatedObject.Loaded -= AssociatedObject_Loaded;
            var tb = (SpecializedTextBox)Infragistics.Windows.Utilities.GetDescendantFromType(AssociatedObject, typeof(SpecializedTextBox), false); //GetDescendantFromName(AssociatedObject, "TextBoxPresenter");
            if (tb != null)
            {
                tb.TextChanged += tb_TextChanged;
                tb.GotFocus += tb_GotFoccused;

                Binding bind = new Binding();
                bind.Path = new PropertyPath("SelectedPanelistValue");
                bind.Source = AssociatedObject;
                bind.Mode = BindingMode.TwoWay;
                bind.UpdateSourceTrigger = UpdateSourceTrigger.PropertyChanged;
                BindingOperations.SetBinding(tb, TextBox.TextProperty, bind);
            }
            base.OnDetaching();
        }

        private void tb_GotFoccused(object sender, System.Windows.RoutedEventArgs e)
        {
            var tb = (SpecializedTextBox)Infragistics.Windows.Utilities.GetDescendantFromType(AssociatedObject, typeof(SpecializedTextBox), false); //GetDescendantFromName(AssociatedObject, "TextBoxPresenter");

            if (string.IsNullOrEmpty(tb.Text))
            {
                AssociatedObject.IsDropDownOpen = true;
            }
        }

        void tb_TextChanged(object sender, System.Windows.Controls.TextChangedEventArgs e)
        {
            SpecializedTextBox tb = sender as SpecializedTextBox;

            if (string.IsNullOrEmpty(tb.Text))
            {
                this.AssociatedObject.IsDropDownOpen = true;
                return;
            }
        }
    }
}
