﻿using Infragistics.Controls.Editors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;

namespace TestHdadmProject.CustomControls
{
    public class HDADMXamComboEditor : XamComboEditor
    {
        //Property for ImageSrc
        public static ImageSource GetImageSrc(DependencyObject obj)
        {
            return (ImageSource)obj.GetValue(ImageSrcProperty);
        }

        public static void SetImageSrc(DependencyObject obj, ImageSource value)
        {
            obj.SetValue(ImageSrcProperty, value);
        }

        public static readonly DependencyProperty ImageSrcProperty =
            DependencyProperty.RegisterAttached("ImageSrc", typeof(ImageSource), typeof(HDADMXamComboEditor), new PropertyMetadata());

        //Property for HoverImageSrc
        public static ImageSource GetAltImageSrc(DependencyObject obj)
        {
            return (ImageSource)obj.GetValue(AltImageSrcProperty);
        }

        public static void SetAltImageSrc(DependencyObject obj, ImageSource value)
        {
            obj.SetValue(AltImageSrcProperty, value);
        }

        public static readonly DependencyProperty AltImageSrcProperty =
            DependencyProperty.RegisterAttached("AltImageSrc", typeof(ImageSource), typeof(HDADMXamComboEditor), new PropertyMetadata());

        //Propoerty to Show Search Icon
        public static Visibility GetIsSearchIconVisible(DependencyObject obj)
        {
            return (Visibility)obj.GetValue(SearchIconVisibleProperty);
        }

        public static void SetSearchIconVisible(DependencyObject obj, Visibility value)
        {
            obj.SetValue(SearchIconVisibleProperty, value);
        }

        public static readonly DependencyProperty SearchIconVisibleProperty =
            DependencyProperty.RegisterAttached("SearchIconVisible", typeof(Visibility), typeof(HDADMXamComboEditor), new PropertyMetadata(Visibility.Visible));

        //Propoerty to Show Label Icon
        public static Visibility GetLabelIconVisible(DependencyObject obj)
        {
            return (Visibility)obj.GetValue(LabelIconVisibleProperty);
        }

        public static void SetLabelIconVisible(DependencyObject obj, Visibility value)
        {
            obj.SetValue(LabelIconVisibleProperty, value);
        }

        public static readonly DependencyProperty LabelIconVisibleProperty =
            DependencyProperty.RegisterAttached("LabelIconVisible", typeof(Visibility), typeof(HDADMXamComboEditor), new PropertyMetadata(Visibility.Visible));

        //Property for WaterMark
        public static string GetWatermark(DependencyObject obj)
        {
            return (string)obj.GetValue(WatermarkProperty);
        }

        public static void SetWatermark(DependencyObject obj, string value)
        {
            obj.SetValue(WatermarkProperty, value);
        }

        public static readonly DependencyProperty WatermarkProperty =
            DependencyProperty.RegisterAttached("Watermark", typeof(string), typeof(HDADMXamComboEditor), new PropertyMetadata(""));


        //Selected Value of Panelist.
        public static string GetSelectedPanelistValue(DependencyObject obj)
        {
            return (string)obj.GetValue(SelectedPanelistValueProperty);
        }

        public static void SetSelectedPanelistValue(DependencyObject obj, string value)
        {
            obj.SetValue(SelectedPanelistValueProperty, value);
        }

        // Using a DependencyProperty as the backing store for SelectedPanelistValue.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty SelectedPanelistValueProperty =
            DependencyProperty.RegisterAttached("SelectedPanelistValue", typeof(string), typeof(HDADMXamComboEditor), new PropertyMetadata());

    }
}
